diff --git a/src/BSplSLib/BSplSLib_MultiSpanCache.cxx b/src/BSplSLib/BSplSLib_MultiSpanCache.cxx
new file mode 100644
index 0000000000..4e50ef06a4
--- /dev/null
+++ b/src/BSplSLib/BSplSLib_MultiSpanCache.cxx
@@ -0,0 +1,235 @@
+// Copyright (c) 2014 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#include <BSplSLib_MultiSpanCache.hxx>
+
+#include <BSplCLib.hxx>
+#include <ElCLib.hxx>
+#include <Precision.hxx>
+
+BSplSLib_MultiSpanCache::BSplSLib_MultiSpanCache(const Standard_Integer         theDegreeU,
+                                                 const Standard_Boolean         thePeriodicU,
+                                                 const Standard_Integer         theDegreeV,
+                                                 const Standard_Boolean         thePeriodicV,
+                                                 const TColgp_Array2OfPnt&      thePoles,
+                                                 const TColStd_Array2OfReal*    theWeights)
+  : myDegreeU(theDegreeU),
+    myDegreeV(theDegreeV),
+    myPeriodicU(thePeriodicU),
+    myPeriodicV(thePeriodicV),
+    myKnotsU(NULL),
+    myKnotsV(NULL),
+    myMultsU(NULL),
+    myMultsV(NULL),
+    myFlatKnotsU(NULL),
+    myFlatKnotsV(NULL),
+    myFirstKnotU(0.),
+    myFirstKnotV(0.),
+    myLastKnotU(1.),
+    myLastKnotV(1.),
+    myPoles(thePoles),
+    myWeights(theWeights),
+    mySingleSpanU(1),
+    mySingleSpanV(1),
+    myCaches(1)
+{
+  Clear();
+
+  // Build cache for single span
+  TColStd_Array1OfReal aFlatKnotsU(BSplCLib::FlatBezierKnots(myDegreeU), 1, (myDegreeU + 1) * 2);
+  TColStd_Array1OfReal aFlatKnotsV(BSplCLib::FlatBezierKnots(myDegreeV), 1, (myDegreeV + 1) * 2);
+  myCaches[myLastCacheInd] = new BSplSLib_Cache;
+  myCaches[myLastCacheInd]->BuildCache(myDegreeU, myPeriodicU, aFlatKnotsU, myDegreeU + 1,
+                                       myDegreeV, myPeriodicV, aFlatKnotsV, myDegreeV + 1,
+                                       myPoles, myWeights);
+}
+
+BSplSLib_MultiSpanCache::BSplSLib_MultiSpanCache(const Standard_Integer         theDegreeU,
+                                                 const Standard_Boolean         thePeriodicU,
+                                                 const TColStd_Array1OfReal*    theKnotsU,
+                                                 const TColStd_Array1OfInteger* theMultsU,
+                                                 const TColStd_Array1OfReal*    theFlatKnotsU,
+                                                 const Standard_Integer         theDegreeV,
+                                                 const Standard_Boolean         thePeriodicV,
+                                                 const TColStd_Array1OfReal*    theKnotsV,
+                                                 const TColStd_Array1OfInteger* theMultsV,
+                                                 const TColStd_Array1OfReal*    theFlatKnotsV,
+                                                 const TColgp_Array2OfPnt&      thePoles,
+                                                 const TColStd_Array2OfReal*    theWeights)
+  : myDegreeU(theDegreeU),
+    myDegreeV(theDegreeV),
+    myPeriodicU(thePeriodicU),
+    myPeriodicV(thePeriodicV),
+    myKnotsU(theKnotsU),
+    myKnotsV(theKnotsV),
+    myMultsU(theMultsU),
+    myMultsV(theMultsV),
+    myFlatKnotsU(theFlatKnotsU),
+    myFlatKnotsV(theFlatKnotsV),
+    myFirstKnotU(theKnotsU->First()),
+    myFirstKnotV(theKnotsV->First()),
+    myLastKnotU(theKnotsU->Last()),
+    myLastKnotV(theKnotsV->Last()),
+    myPoles(thePoles),
+    myWeights(theWeights),
+    mySingleSpanU(0),
+    mySingleSpanV(0),
+    myCaches((theKnotsU->Upper() - theKnotsU->Lower()) * (theKnotsV->Upper() - theKnotsV->Lower()))
+{
+  Clear();
+
+  Standard_Boolean isSingleSpanU = myKnotsU->Length() == 2;
+  Standard_Boolean isSingleSpanV = myKnotsV->Length() == 2;
+
+  // Check the surface has one span at all
+  if (isSingleSpanU || isSingleSpanV)
+  {
+    Standard_Integer aSpanIndex; // works as temporary index if surface has more than one span
+    Standard_Real aTempU = myKnotsU->First();
+    Standard_Real aTempV = myKnotsV->First();
+    SpanIndex(aTempU, aTempV,
+              isSingleSpanU ? mySingleSpanU : aSpanIndex,
+              isSingleSpanV ? mySingleSpanV : aSpanIndex);
+  }
+}
+
+BSplSLib_MultiSpanCache::~BSplSLib_MultiSpanCache()
+{
+  Standard_Integer aSize = (Standard_Integer)myCaches.Size();
+  for (Standard_Integer i = 0; i < aSize; ++i)
+    myCaches[i].Nullify();
+}
+
+void BSplSLib_MultiSpanCache::Clear()
+{
+  myLastCacheInd = 0;
+  myLastU.myParameter = Precision::Infinite();
+  myLastU.mySpan = -1;
+  myLastV.myParameter = Precision::Infinite();
+  myLastV.mySpan = -1;
+}
+
+void BSplSLib_MultiSpanCache::D0(const Standard_Real theU,
+                                 const Standard_Real theV,
+                                       gp_Pnt&       thePoint)
+{
+  Standard_Real aU = theU;
+  Standard_Real aV = theV;
+  const Handle(BSplSLib_Cache)& aCache = FindCache(aU, aV);
+  aCache->D0(aU, aV, thePoint);
+}
+
+void BSplSLib_MultiSpanCache::D1(const Standard_Real theU,
+                                 const Standard_Real theV, 
+                                       gp_Pnt&       thePoint, 
+                                       gp_Vec&       theTangentU, 
+                                       gp_Vec&       theTangentV)
+{
+  Standard_Real aU = theU;
+  Standard_Real aV = theV;
+  const Handle(BSplSLib_Cache)& aCache = FindCache(aU, aV);
+  aCache->D1(aU, aV, thePoint, theTangentU, theTangentV);
+}
+
+void BSplSLib_MultiSpanCache::D2(const Standard_Real theU,
+                                 const Standard_Real theV, 
+                                       gp_Pnt&       thePoint, 
+                                       gp_Vec&       theTangentU, 
+                                       gp_Vec&       theTangentV, 
+                                       gp_Vec&       theCurvatureU, 
+                                       gp_Vec&       theCurvatureV, 
+                                       gp_Vec&       theCurvatureUV)
+{
+  Standard_Real aU = theU;
+  Standard_Real aV = theV;
+  const Handle(BSplSLib_Cache)& aCache = FindCache(aU, aV);
+  aCache->D2(aU, aV, thePoint, theTangentU, theTangentV,
+             theCurvatureU, theCurvatureV, theCurvatureUV);
+}
+
+Standard_Integer BSplSLib_MultiSpanCache::SpanIndex(const Standard_Real theU,
+                                                    const Standard_Real theV,
+                                                    Standard_Integer&   theSpanIndexU,
+                                                    Standard_Integer&   theSpanIndexV) const
+{
+  // Get indices along each parameter (U, V)
+  theSpanIndexU = mySingleSpanU;
+  theSpanIndexV = mySingleSpanV;
+  if (IsSingleSpan())
+    return 0;
+
+  if (theSpanIndexU == 0)
+  {
+    if (theU == myLastU.myParameter) // the parameters should be equal to a bit
+      theSpanIndexU = myLastU.mySpan;
+    else
+    {
+      Standard_Real aNewU = theU; // unused parameter, because theU is already in period
+      BSplCLib::LocateParameter(myDegreeU, *myKnotsU, myMultsU, theU, myPeriodicU,
+                                theSpanIndexU, aNewU);
+    }
+  }
+  if (theSpanIndexV == 0)
+  {
+    if (theV == myLastV.myParameter) // the parameters should be equal to a bit
+      theSpanIndexV = myLastV.mySpan;
+    else
+    {
+      Standard_Real aNewV = theV; // unused parameter, because theV is already in period
+      BSplCLib::LocateParameter(myDegreeV, *myKnotsV, myMultsV, theV, myPeriodicV,
+                                theSpanIndexV, aNewV);
+    }
+  }
+  return (theSpanIndexU - myKnotsU->Lower()) * (myKnotsV->Upper() - myKnotsV->Lower()) +
+          theSpanIndexV - myKnotsV->Lower();
+}
+
+const Handle(BSplSLib_Cache)& BSplSLib_MultiSpanCache::FindCache(Standard_Real& theU, Standard_Real& theV)
+{
+  // Normalize the parameters for periodical B-splines
+  if (myPeriodicU && (theU > myLastKnotU || theU < myFirstKnotU))
+    theU = ElCLib::InPeriod(theU, myFirstKnotU, myLastKnotU);
+  if (myPeriodicV && (theV > myLastKnotV || theV < myFirstKnotV))
+    theV = ElCLib::InPeriod(theV, myFirstKnotV, myLastKnotV);
+
+  // Do not want to search in due to lack of performance.
+  // Just check the last used cache is valid for the given parameters.
+  if (!myCaches[myLastCacheInd].IsNull() &&
+      (IsSingleSpan() || myCaches[myLastCacheInd]->IsCacheValid(theU, theV)))
+    return myCaches[myLastCacheInd];
+
+  Standard_Integer aSpanIndexU = 0;
+  Standard_Integer aSpanIndexV = 0;
+  myLastCacheInd = SpanIndex(theU, theV, aSpanIndexU, aSpanIndexV);
+  // store last found indices
+  myLastU.myParameter = theU;
+  myLastU.mySpan = aSpanIndexU;
+  myLastV.myParameter = theV;
+  myLastV.mySpan = aSpanIndexV;
+
+  // check the cache is already built
+  Handle(BSplSLib_Cache)& aCache = myCaches[myLastCacheInd];
+  if (aCache.IsNull())
+  {
+    // calculate index of cache for the flat knots
+    aSpanIndexU = BSplCLib::FlatIndex(myDegreeU, aSpanIndexU, *myMultsU, myPeriodicU);
+    aSpanIndexV = BSplCLib::FlatIndex(myDegreeV, aSpanIndexV, *myMultsV, myPeriodicV);
+    // build new cache
+    aCache = new BSplSLib_Cache;
+    aCache->BuildCache(myDegreeU, myPeriodicU, *myFlatKnotsU, aSpanIndexU,
+                       myDegreeV, myPeriodicV, *myFlatKnotsV, aSpanIndexV,
+                       myPoles, myWeights);
+  }
+
+  return aCache;
+}
diff --git a/src/BSplSLib/BSplSLib_MultiSpanCache.hxx b/src/BSplSLib/BSplSLib_MultiSpanCache.hxx
new file mode 100644
index 0000000000..ab6b759156
--- /dev/null
+++ b/src/BSplSLib/BSplSLib_MultiSpanCache.hxx
@@ -0,0 +1,171 @@
+// Copyright (c) 2016 OPEN CASCADE SAS
+//
+// This file is part of Open CASCADE Technology software library.
+//
+// This library is free software; you can redistribute it and/or modify it under
+// the terms of the GNU Lesser General Public License version 2.1 as published
+// by the Free Software Foundation, with special exception defined in the file
+// OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
+// distribution for complete text of the license and disclaimer of any warranty.
+//
+// Alternatively, this file may be used under the terms of Open CASCADE
+// commercial license or contractual agreement.
+
+#ifndef _BSplSLib_MultiSpanCache_Headerfile
+#define _BSplSLib_MultiSpanCache_Headerfile
+
+#include <BSplSLib_Cache.hxx>
+#include <NCollection_LocalArray.hxx>
+
+//! \brief A container for list of caches for Bezier and B-spline surfaces.
+//!        Stores a 2D array of caches. Each cache is initialized in first time called.
+class BSplSLib_MultiSpanCache : public Standard_Transient
+{
+public:
+  //! Construct cache for Bezier surface with given parameters
+  //! \param theDegreeU    [in] degree along the first parameter (U) of the surface
+  //! \param thePeriodicU  [in] identify the surface is periodical along U axis
+  //! \param theDegreeV    [in] degree along the second parameter (V) of the surface
+  //! \param thePeriodicV  [in] identify the surface is periodical along V axis
+  //! \param thePoles      [in] array of poles of the surface
+  //! \param theWeights    [in] array of weights of corresponding poles
+  //! \param theMaxSpans   [in] maximal spans to be cached
+  Standard_EXPORT BSplSLib_MultiSpanCache(const Standard_Integer         theDegreeU,
+                                          const Standard_Boolean         thePeriodicU,
+                                          const Standard_Integer         theDegreeV,
+                                          const Standard_Boolean         thePeriodicV,
+                                          const TColgp_Array2OfPnt&      thePoles,
+                                          const TColStd_Array2OfReal*    theWeights  = NULL);
+
+  //! Construct multi-span cache for B-spline surface with given parameters
+  //! \param theDegreeU    [in] degree along the first parameter (U) of the surface
+  //! \param thePeriodicU  [in] identify the surface is periodical along U axis
+  //! \param theKnotsU     [in] knots of the surface along U axis
+  //! \param theMultsU     [in] multiplicities of knots along U axis
+  //! \param theFlatKnotsU [in] knots of the surface (with repetition) along U axis
+  //! \param theDegreeV    [in] degree alogn the second parameter (V) of the surface
+  //! \param thePeriodicV  [in] identify the surface is periodical along V axis
+  //! \param theKnotsV     [in] knots of the surface along V axis
+  //! \param theMultsV     [in] multiplicities of knots along V axis
+  //! \param theFlatKnotsV [in] knots of the surface (with repetition) along V axis
+  //! \param thePoles      [in] array of poles of the surface
+  //! \param theWeights    [in] array of weights of corresponding poles
+  //! \param theMaxSpans   [in] maximal spans to be cached
+  Standard_EXPORT BSplSLib_MultiSpanCache(const Standard_Integer         theDegreeU,
+                                          const Standard_Boolean         thePeriodicU,
+                                          const TColStd_Array1OfReal*    theKnotsU,
+                                          const TColStd_Array1OfInteger* theMultsU,
+                                          const TColStd_Array1OfReal*    theFlatKnotsU,
+                                          const Standard_Integer         theDegreeV,
+                                          const Standard_Boolean         thePeriodicV,
+                                          const TColStd_Array1OfReal*    theKnotsV,
+                                          const TColStd_Array1OfInteger* theMultsV,
+                                          const TColStd_Array1OfReal*    theFlatKnotsV,
+                                          const TColgp_Array2OfPnt&      thePoles,
+                                          const TColStd_Array2OfReal*    theWeights  = NULL);
+
+  virtual ~BSplSLib_MultiSpanCache();
+
+  //! Clean all cached data
+  Standard_EXPORT void Clear();
+
+  //! Calculates the point on the surface for specified parameters
+  //! \param theU     [in]  first parameter for calculation of the value
+  //! \param theV     [in]  second parameter for calculation of the value
+  //! \param thePoint [out] the result of calculation (the point on the surface)
+  Standard_EXPORT void D0(const Standard_Real theU, const Standard_Real theV, gp_Pnt& thePoint);
+
+  //! Calculates the point on the surface and its first derivative
+  //! \param theU        [in]  first parameter of calculation of the value
+  //! \param theV        [in]  second parameter of calculation of the value
+  //! \param thePoint    [out] the result of calculation (the point on the surface)
+  //! \param theTangentU [out] tangent vector along U axis in the calculated point
+  //! \param theTangentV [out] tangent vector along V axis in the calculated point
+  Standard_EXPORT void D1(const Standard_Real theU, 
+                          const Standard_Real theV, 
+                                gp_Pnt&       thePoint, 
+                                gp_Vec&       theTangentU, 
+                                gp_Vec&       theTangentV);
+
+  //! Calculates the point on the surface and derivatives till second order
+  //! \param theU           [in]  first parameter of calculation of the value
+  //! \param theV           [in]  second parameter of calculation of the value
+  //! \param thePoint       [out] the result of calculation (the point on the surface)
+  //! \param theTangentU    [out] tangent vector along U axis in the calculated point
+  //! \param theTangentV    [out] tangent vector along V axis in the calculated point
+  //! \param theCurvatureU  [out] curvature vector (2nd derivative on U) along U axis
+  //! \param theCurvatureV  [out] curvature vector (2nd derivative on V) along V axis
+  //! \param theCurvatureUV [out] 2nd mixed derivative on U anv V
+  Standard_EXPORT void D2(const Standard_Real theU, 
+                          const Standard_Real theV, 
+                                gp_Pnt&       thePoint, 
+                                gp_Vec&       theTangentU, 
+                                gp_Vec&       theTangentV, 
+                                gp_Vec&       theCurvatureU, 
+                                gp_Vec&       theCurvatureV, 
+                                gp_Vec&       theCurvatureUV);
+
+
+  DEFINE_STANDARD_RTTI_INLINE(BSplSLib_MultiSpanCache, Standard_Transient)
+
+private:
+  //! Calculate an index of a span by the parameters on surface
+  //! and corresponding span indices along each parameter.
+  //! \param theU          [in]  parameter U
+  //! \param theV          [in]  parameter V
+  //! \param theSpanIndexU [out] index of span containing theU parameter
+  //! \param theSpanIndexV [out] index of span containing theV parameter
+  //! \return Index of the cache in the array
+  Standard_Integer SpanIndex(const Standard_Real theU,
+                             const Standard_Real theV,
+                             Standard_Integer&   theSpanIndexU,
+                             Standard_Integer&   theSpanIndexV) const;
+
+  //! Find cached span containing parametric point (theU, theV).
+  //! Parameters are adjusted to period for periodic surface.
+  //! If such span is not cached yet, prepares new cache object.
+  const Handle(BSplSLib_Cache)& FindCache(Standard_Real& theU, Standard_Real& theV);
+
+  //! Return Standard_True if the surface has just one span
+  Standard_Boolean IsSingleSpan() const
+  { return mySingleSpanU != 0 && mySingleSpanV != 0; }
+
+  BSplSLib_MultiSpanCache(const BSplSLib_MultiSpanCache&);
+  const BSplSLib_MultiSpanCache& operator=(const BSplSLib_MultiSpanCache&);
+
+private:
+  typedef NCollection_LocalArray<Handle(BSplSLib_Cache), 1> CacheArray;
+
+  Standard_Integer               myDegreeU;       ///< degree along U
+  Standard_Integer               myDegreeV;       ///< degree along V
+  Standard_Boolean               myPeriodicU;     ///< periodicity along U
+  Standard_Boolean               myPeriodicV;     ///< periodicity along V
+  const TColStd_Array1OfReal*    myKnotsU;        ///< knots along U
+  const TColStd_Array1OfReal*    myKnotsV;        ///< knots along V
+  const TColStd_Array1OfInteger* myMultsU;        ///< multiplicities along U
+  const TColStd_Array1OfInteger* myMultsV;        ///< multiplicities along V
+  const TColStd_Array1OfReal*    myFlatKnotsU;    ///< knots along U (duplicated according to multiplicity)
+  const TColStd_Array1OfReal*    myFlatKnotsV;    ///< knots along V (duplicated according to multiplicity)
+  Standard_Real                  myFirstKnotU;    ///< first knot along U (used for periodic normalization)
+  Standard_Real                  myLastKnotU;     ///< last knot along U (used for periodic normalization)
+  Standard_Real                  myFirstKnotV;    ///< first knot along V (used for periodic normalization)
+  Standard_Real                  myLastKnotV;     ///< last knot along V (used for periodic normalization)
+  const TColgp_Array2OfPnt&      myPoles;         ///< array of poles
+  const TColStd_Array2OfReal*    myWeights;       ///< array of weights
+
+  CacheArray                     myCaches;        ///< array of caches
+  Standard_Integer               myLastCacheInd;  ///< index of last used cache
+
+  struct {
+    Standard_Real    myParameter;
+    Standard_Integer mySpan;
+  }                              myLastU,         ///< last U and index of the span containing it
+                                 myLastV;         ///< last V and index of the span containing it
+
+  Standard_Integer               mySingleSpanU;   ///< index of the span along U, if the surface has just one span on this parameter, otherwise is 0
+  Standard_Integer               mySingleSpanV;   ///< index of the span along V, if the surface has just one span on this parameter, otherwise is 0
+};
+
+DEFINE_STANDARD_HANDLE(BSplSLib_MultiSpanCache, Standard_Transient)
+
+#endif
diff --git a/src/BSplSLib/FILES b/src/BSplSLib/FILES
index a8a96a2cb7..b7bc4db07c 100755
--- a/src/BSplSLib/FILES
+++ b/src/BSplSLib/FILES
@@ -5,3 +5,5 @@ BSplSLib_BzSyntaxes.cxx
 BSplSLib_Cache.cxx
 BSplSLib_Cache.hxx
 BSplSLib_EvaluatorFunction.hxx
+BSplSLib_MultiSpanCache.cxx
+BSplSLib_MultiSpanCache.hxx
diff --git a/src/Geom2dAdaptor/Geom2dAdaptor_Curve.cxx b/src/Geom2dAdaptor/Geom2dAdaptor_Curve.cxx
index 82cb392a03..fa7cf50f43 100644
--- a/src/Geom2dAdaptor/Geom2dAdaptor_Curve.cxx
+++ b/src/Geom2dAdaptor/Geom2dAdaptor_Curve.cxx
@@ -24,7 +24,6 @@
 
 #include <Adaptor2d_HCurve2d.hxx>
 #include <BSplCLib.hxx>
-#include <BSplCLib_Cache.hxx>
 #include <Geom2d_BezierCurve.hxx>
 #include <Geom2d_BSplineCurve.hxx>
 #include <Geom2d_Circle.hxx>
@@ -182,13 +181,14 @@ void Geom2dAdaptor_Curve::load(const Handle(Geom2d_Curve)& C,
   myLast  = ULast;
   myCurveCache.Nullify();
 
-  if ( myCurve != C) {
+  if (myCurve != C)
+  {
     myCurve = C;
     myNestedEvaluator.Nullify();
     myBSplineCurve.Nullify();
 
-    Handle(Standard_Type) TheType = C->DynamicType();
-    if ( TheType == STANDARD_TYPE(Geom2d_TrimmedCurve)) {
+    const Handle(Standard_Type)& TheType = C->DynamicType();
+    if (TheType == STANDARD_TYPE(Geom2d_TrimmedCurve)) {
       Load(Handle(Geom2d_TrimmedCurve)::DownCast (C)->BasisCurve(),
 	   UFirst,ULast);
     }
@@ -546,36 +546,6 @@ Standard_Real Geom2dAdaptor_Curve::Period() const
   return myCurve->LastParameter() - myCurve->FirstParameter();
 }
 
-//=======================================================================
-//function : RebuildCache
-//purpose  : 
-//=======================================================================
-void Geom2dAdaptor_Curve::RebuildCache(const Standard_Real theParameter) const
-{
-  if (myTypeCurve == GeomAbs_BezierCurve)
-  {
-    // Create cache for Bezier
-    Handle(Geom2d_BezierCurve) aBezier = Handle(Geom2d_BezierCurve)::DownCast(myCurve);
-    Standard_Integer aDeg = aBezier->Degree();
-    TColStd_Array1OfReal aFlatKnots(BSplCLib::FlatBezierKnots(aDeg), 1, 2 * (aDeg + 1));
-    if (myCurveCache.IsNull())
-      myCurveCache = new BSplCLib_Cache(aDeg, aBezier->IsPeriodic(), aFlatKnots,
-        aBezier->Poles(), aBezier->Weights());
-    myCurveCache->BuildCache(theParameter, aDeg, aBezier->IsPeriodic(), aFlatKnots,
-      aBezier->Poles(), aBezier->Weights());
-  }
-  else if (myTypeCurve == GeomAbs_BSplineCurve)
-  {
-    // Create cache for B-spline
-    if (myCurveCache.IsNull())
-      myCurveCache = new BSplCLib_Cache(myBSplineCurve->Degree(), myBSplineCurve->IsPeriodic(),
-        myBSplineCurve->KnotSequence(), myBSplineCurve->Poles(), myBSplineCurve->Weights());
-    myCurveCache->BuildCache(theParameter, myBSplineCurve->Degree(),
-      myBSplineCurve->IsPeriodic(), myBSplineCurve->KnotSequence(),
-      myBSplineCurve->Poles(), myBSplineCurve->Weights());
-  }
-}
-
 //=======================================================================
 //function : IsBoundary
 //purpose  : 
@@ -607,6 +577,34 @@ Standard_Boolean Geom2dAdaptor_Curve::IsBoundary(const Standard_Real theU,
   return Standard_False;
 }
 
+//=======================================================================
+//function : CreateCache
+//purpose  : 
+//=======================================================================
+
+void Geom2dAdaptor_Curve::CreateCache() const
+{
+  switch (myTypeCurve)
+  {
+  case GeomAbs_BezierCurve: {
+    // Create cache for Bezier
+    Handle(Geom2d_BezierCurve) aBezier = Handle(Geom2d_BezierCurve)::DownCast(myCurve);
+    myCurveCache = new BSplCLib_MultiSpanCache2D(aBezier->Degree(), aBezier->IsPeriodic(),
+        aBezier->Poles(), aBezier->Weights());
+    break;
+  }
+  case GeomAbs_BSplineCurve:
+    // Create cache for B-spline
+    myCurveCache = new BSplCLib_MultiSpanCache2D(
+        myBSplineCurve->Degree(), myBSplineCurve->IsPeriodic(),
+        &myBSplineCurve->Knots(), &myBSplineCurve->Multiplicities(),
+        &myBSplineCurve->KnotSequence(), myBSplineCurve->Poles(), myBSplineCurve->Weights());
+    break;
+  default: // avoid gcc compilation warnings
+    break; 
+  }
+}
+
 //=======================================================================
 //function : Value
 //purpose  : 
@@ -633,14 +631,11 @@ void Geom2dAdaptor_Curve::D0(const Standard_Real U, gp_Pnt2d& P) const
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD0(U, aStart, aFinish, P);
-    }
     else
     {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D0(U, P);
     }
     break;
@@ -670,14 +665,11 @@ void Geom2dAdaptor_Curve::D1(const Standard_Real U,
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD1(U, aStart, aFinish, P, V);
-    }
     else
     {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D1(U, P, V);
     }
     break;
@@ -707,14 +699,11 @@ void Geom2dAdaptor_Curve::D2(const Standard_Real U,
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD2(U, aStart, aFinish, P, V1, V2);
-    }
     else
     {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D2(U, P, V1, V2);
     }
     break;
@@ -745,14 +734,11 @@ void Geom2dAdaptor_Curve::D3(const Standard_Real U,
   {
     Standard_Integer aStart = 0, aFinish = 0;
     if (IsBoundary(U, aStart, aFinish))
-    {
       myBSplineCurve->LocalD3(U, aStart, aFinish, P, V1, V2, V3);
-    }
     else
     {
-      // use cached data
-      if (myCurveCache.IsNull() || !myCurveCache->IsCacheValid(U))
-        RebuildCache(U);
+      if (myCurveCache.IsNull())
+        CreateCache();
       myCurveCache->D3(U, P, V1, V2, V3);
     }
     break;
diff --git a/src/Geom2dAdaptor/Geom2dAdaptor_Curve.hxx b/src/Geom2dAdaptor/Geom2dAdaptor_Curve.hxx
index 6ecbf6a5c4..0dfd760abf 100644
--- a/src/Geom2dAdaptor/Geom2dAdaptor_Curve.hxx
+++ b/src/Geom2dAdaptor/Geom2dAdaptor_Curve.hxx
@@ -23,7 +23,7 @@
 
 #include <GeomAbs_CurveType.hxx>
 #include <Standard_Real.hxx>
-#include <BSplCLib_Cache.hxx>
+#include <BSplCLib_MultiSpanCache.hxx>
 #include <Adaptor2d_Curve2d.hxx>
 #include <GeomAbs_Shape.hxx>
 #include <Standard_Integer.hxx>
@@ -187,9 +187,8 @@ private:
   //! Check theU relates to start or finish point of B-spline curve and return indices of span the point is located
   Standard_Boolean IsBoundary(const Standard_Real theU, Standard_Integer& theSpanStart, Standard_Integer& theSpanFinish) const;
 
-  //! Rebuilds B-spline cache
-  //! \param theParameter the value on the knot axis which identifies the caching span
-  void RebuildCache (const Standard_Real theParameter) const;
+  //! Allocates memory for a cache object
+  void CreateCache() const;
 
 
   Handle(Geom2d_Curve) myCurve;
@@ -198,7 +197,7 @@ private:
   Standard_Real myLast;
 
   Handle(Geom2d_BSplineCurve) myBSplineCurve; ///< B-spline representation to prevent castings
-  mutable Handle(BSplCLib_Cache) myCurveCache; ///< Cached data for B-spline or Bezier curve
+  mutable Handle(BSplCLib_MultiSpanCache2D) myCurveCache; ///< Cached data for B-spline or Bezier curve
   Handle(Geom2dEvaluator_Curve) myNestedEvaluator; ///< Calculates value of offset curve
 
 
